/* All needed header files */
 
/* Copyright (c) 2015, Robert Bosch GmbH, Gerlingen, Germany
*  All rights reserved.
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions are met:
*     1. Redistributions of source code must retain the above copyright
*        notice, this list of conditions and the following disclaimer.
*     2. Redistributions in binary form must reproduce the above copyright
*        notice, this list of conditions and the following disclaimer in the
*        documentation and/or other materials provided with the distribution.
*     3. Neither the name of the Robert Bosch GmbH nor the
*        names of its contributors may be used to endorse or promote products
*        derived from this software without specific prior written permission.
*  
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
*  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
*  DISCLAIMED. IN NO EVENT SHALL the Robert Bosch GmbH BE LIABLE FOR ANY
*  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
*  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
*  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
*  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
   Note: This software is snapshot of an ongoing project and serves as example.
*/

#ifndef M_CAN_INCLUDES_H
#define M_CAN_INCLUDES_H 

/* Global Definitions */
#include "global_settings.h"  // has to be included prior to types.h, otherwise the Software doesn work with Xilinx Microblaze/SDK
#include "types.h"

/* Common C header files */
//#define NDEBUG // If this is defined, asserts are turned OFF. Comment out this line to enable asserts.
#include "assert.h"
#include "stdio.h"
#include "string.h" /* memset */

#if __ALTERA
/* ALTERA C header file(s) */
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"
#include "sys/alt_irq.h"

#elif __XILINX
/* XILINX C header files */
#include "xparameters.h"
#include "xil_cache.h"
#include "xbasic_types.h"
#include "xil_io.h"
#include "xgpio.h"
#include "xstatus.h"
#include "xintc.h"
#include "xtmrctr.h" // timer/counter
#include "xil_exception.h"

/* Xilinx C header file(s) - modified by Bosch */
#include "xilinx/xilinx_specific.h" // Xilinx specific redefines (important)
#include "xilinx/xilinx_gpio.h"
#include "xilinx/xilinx_tmrctr.h"
#include "xilinx/xilinx_intcontroller.h"
#endif // __XILINX

/* Common User Defined header files */
#include "peripherals.h"     // FPGA board peripheral specific functions
#include "can_io_wiring.h"   // CAN IO Wiring Module drivers

/* M_CAN IP related header files */
#include "m_can/m_can_regdef.h"
#include "m_can/m_can.h"
#include "m_can/m_can_irq_handling.h"
#include "m_can/m_can_helper_func.h"

/* M_CAN Application Examples - header files */
#include "app_notes/app_note_001_rx_handling.h"
#include "app_notes/app_note_002_tx_handling.h"

#endif /*M_CAN_INCLUDES_H*/
